Index: palm/trunk/SOURCE/pres.f90
===================================================================
--- palm/trunk/SOURCE/pres.f90	(revision 1932)
+++ palm/trunk/SOURCE/pres.f90	(revision 1933)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+!
+! 1932 2016-06-10 12:09:21Z suehring
+! Initial version of purely vertical nesting introduced.
 !
 ! 1931 2016-06-10 12:06:59Z suehring
@@ -127,6 +130,5 @@
                gathered_size, ibc_p_b, ibc_p_t, intermediate_timestep_count,   &
                intermediate_timestep_count_max, mg_switch_to_pe0_level,        &
-               nest_domain, nest_bound_l, nest_bound_n, nest_bound_r,          &
-               nest_bound_s, on_device, outflow_l, outflow_n, outflow_r,       &
+               nest_domain, on_device, outflow_l, outflow_n, outflow_r,        &
                outflow_s, psolver, subdomain_size, topography, volume_flow,    &
                volume_flow_area, volume_flow_initial
@@ -147,4 +149,7 @@
 
     USE pegrid
+    
+    USE pmc_interface,                                                         &
+        ONLY:  nesting_mode 
 
     USE poisfft_mod,                                                           &
@@ -174,4 +179,6 @@
     REAL(wp), DIMENSION(1:nzt) ::  w_l                 !<
     REAL(wp), DIMENSION(1:nzt) ::  w_l_l               !<
+
+    LOGICAL :: nest_domain_nvn      !<
 
 
@@ -312,9 +319,17 @@
 !
 !-- Remove mean vertical velocity in case that Neumann conditions are
-!-- used both at bottom and top boundary, and if not a nested domain.
+!-- used both at bottom and top boundary, and if not a nested domain in a 
+!-- normal nesting run. In case of vertical nesting, this must be done.
+!-- Therefore an auxiliary logical variable nest_domain_nvn is used here, and 
+!-- nvn stands for non-vertical nesting. 
 !-- This cannot be done before the first initial time step because ngp_2dh_outer
 !-- is not yet known then.
-    IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1  .AND.  .NOT. nest_domain  .AND.    &
-         intermediate_timestep_count /= 0 )                                    &
+    nest_domain_nvn = nest_domain
+    IF ( nest_domain .AND. nesting_mode == 'vertical' )  THEN
+       nest_domain_nvn = .FALSE.
+    ENDIF
+
+    IF ( ibc_p_b == 1  .AND.  ibc_p_t == 1  .AND.                               &
+         .NOT. nest_domain_nvn  .AND. intermediate_timestep_count /= 0 )        &
     THEN
        w_l = 0.0_wp;  w_l_l = 0.0_wp
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1932)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1933)
@@ -25,7 +25,6 @@
 ! $Id$
 !
-! 1927 2016-06-07 11:56:53Z hellstea
-! Synchronization moved before CALL run_control. Exchange_horiz for pt after 
-! CALL pmci_datatrans is now only called if ( .NOT. neutral ).  
+! 1919 2016-05-27 14:51:23Z raasch
+! Initial version of purely vertical nesting introduced. 
 !
 ! 1918 2016-05-27 14:35:57Z raasch
@@ -298,7 +297,6 @@
 
     USE pmc_interface,                                                         &
-        ONLY:  client_to_server, nested_run, nesting_mode,                     &
-               pmci_datatrans, pmci_ensure_nest_mass_conservation,             &
-               pmci_synchronize, server_to_client
+        ONLY:  nested_run, nesting_mode, pmci_datatrans,                       &
+               pmci_ensure_nest_mass_conservation, pmci_synchronize
 
     USE production_e_mod,                                                      &
@@ -726,6 +724,6 @@
              CALL cpu_log( log_point(60), 'nesting', 'start' )
 !
-!--          Domain nesting. The data transfer subroutines pmci_server_datatrans
-!--          and pmci_client_datatatrans are called inside the wrapper
+!--          Domain nesting. The data transfer subroutines pmci_parent_datatrans
+!--          and pmci_child_datatrans are called inside the wrapper
 !--          subroutine pmci_datatrans according to the control parameters
 !--          nesting_mode and nesting_datatransfer_mode.
@@ -733,7 +731,8 @@
              CALL pmci_datatrans( nesting_mode )
 
-             IF ( nesting_mode == 'two-way' )  THEN
-!
-!--             Exchange_horiz is needed for all server-domains after the
+             IF ( TRIM( nesting_mode ) == 'two-way' .OR.                               &
+                  nesting_mode == 'vertical' )  THEN
+!
+!--             Exchange_horiz is needed for all parent-domains after the
 !--             anterpolation
                 CALL exchange_horiz( u, nbgp )
@@ -750,5 +749,6 @@
 !
 !--          Correct the w top-BC in nest domains to ensure mass conservation.
-!--          This action must never be done for the root domain.
+!--          This action must never be done for the root domain. Vertical 
+!--          nesting implies mass conservation.
              IF ( nest_domain )  THEN
                 CALL pmci_ensure_nest_mass_conservation
